/*
 * ICESOFT COMMERCIAL SOURCE CODE LICENSE V 1.1
 *
 * The contents of this file are subject to the ICEsoft Commercial Source
 * Code License Agreement V1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of the
 * License at
 * http://www.icesoft.com/license/commercial-source-v1.1.html
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under
 * the License.
 *
 * Copyright 2009-2015 ICEsoft Technologies Canada, Corp. All Rights Reserved.
 */
package com.icesoft.faces.facelets.component.util;


import org.icefaces.impl.util.Util;

import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * This class is a utility class for determining if a Component is within a
 * component hierarchy of components that has singleSubmit enabled.  When the
 * new ICEfaces 2.0 SingleSubmit component is present older ICEfaces compat
 * components that enable partial submit will not longer work as expected.
 */
@ApplicationScoped
@ManagedBean
public class SubmitStrategy {

    protected final Logger logger = Logger.getLogger(SubmitStrategy.class.getName());

    /**
     * The submit mode of the calling component.
     *
     * @return true if singleSubmit is enabled, false otherwise.
     */
    public boolean isSingleSubmit() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        UIComponent component = facesContext.getApplication()
                .evaluateExpressionGet(facesContext, "#{component}", UIComponent.class);
        boolean isSingleSubmit = Util.withinSingleSubmit(component);
        if (logger.isLoggable(Level.FINER)) {
            logger.finer(component.getClass() + "isSingleSubmit " + isSingleSubmit);
        }
        return isSingleSubmit;
    }

    /**
     * The submit mode of the calling component.
     *
     * @return false if singleSubmit is enabled, true otherwise.
     */
    public boolean isPartialSubmit() {
        boolean isPartialSubmit = !isSingleSubmit();
        return isPartialSubmit;
    }
}
